<template>
	<div id="recipe" class="content">
		<div class="header">
			<h2>Settings: Automation</h2>
		</div>
		<div class="container-fluid">
			<div class="row">
				<div class="col-12">
					<div class="wrapper">
						<tabs @change="switchTab($event)">
							<tab
								v-for="tabItem in tabItems"
								:key="tabItem"
								:name="tabItem"
								:title="tabItem"
							>
								<table class="table table-hover">
									<thead>
										<tr>
											<th :key="`${column.name}`" v-for="column in columns">
												{{ column.title }}
											</th>
											<th></th>
										</tr>
									</thead>
									<tr v-for="(item, index) in processesInfo" :key="index">
										<td scope="row">{{ camelToSpace(item.processId) }}</td>
										<td>{{ item.parameterId }}</td>
										<td>{{ ucFirst(item.parameterType) }}</td>
										<template v-if="!item.isEditing">
											<td>{{ item.value }}</td>
											<td>
												<button class="btn-blue" @click="onEdit(item, index)">
													<font-awesome-icon
														icon="pencil-alt"
													></font-awesome-icon>
												</button>
											</td>
										</template>
										<template v-else>
											<td><input type="number" v-model="item.value" /></td>
											<td>
												<button class="btn-orange" @click="onSave(item, index)">
													<font-awesome-icon icon="save"></font-awesome-icon>
												</button>
												<button class="btn-grey ml-1" @click="onCancel(index)">
													<font-awesome-icon
														icon="window-close"
													></font-awesome-icon>
												</button>
											</td>
										</template>
									</tr>
								</table>
							</tab>
						</tabs>
					</div>
				</div>
			</div>
		</div>
	</div>
</template>

<script>
import Tabs from "../../components/tab/Tabs";
import Tab from "../../components/tab/Tab";
import AutomationService from "@/services/AutomationService";
import helperMixin from "@/mixins/helper";

var tempItem = null;

export default {
	components: {
		Tabs,
		Tab,
	},
	mixins: [helperMixin],
	data() {
		return {
			tabItems: ["DPNR", "ENR-25", "ENR-50"],
			activeTab: "DPNR",
			dpnr: [],
			enr: [],
			dpnrProcesses: [],
			enr25Processes: [],
			enr50Processes: [],
			isEditing: false,
			columns: [
				{
					title: "Process ID",
					name: "processId",
				},
				{
					title: "Parameter ID",
					name: "parameterId",
				},
				{
					title: "Parameter Type",
					name: "parameterType",
				},
				{
					title: "Value",
					name: "value",
				},
				{
					title: "Action",
				},
			],
		};
	},
	computed: {
		/**
		 * Create AutomationService instance.
		 *
		 * @returns {AutomationService}
		 */
		automationService: function () {
			return new AutomationService();
		},

		materialsInfo: function () {
			if (this.activeTab === "DPNR") {
				return this.dpnr;
			}
			return this.enr;
		},

		processesInfo: function () {
			switch (this.activeTab) {
				case "DPNR":
					return this.dpnrProcesses;
				case "ENR-25":
					return this.enr25Processes;
				case "ENR-50":
					return this.enr50Processes;
				default:
					return [];
			}
		},
	},
	async mounted() {
		this.showLoadingOverlay();

		let dpnrMixing = await this.automationService.getProcessSetting(
			"DpnrMixing",
			"DPNR"
		);
		let dpnrCoagulation = await this.automationService.getProcessSetting(
			"DpnrCoagulation",
			"DPNR"
		);
		let dpnrCreeping = await this.automationService.getProcessSetting(
			"DpnrCreeping",
			"DPNR"
		);

		let enr25Mixing = await this.automationService.getProcessSetting(
			"EnrMixing",
			"ENR-25"
		);
		let enr25Heating = await this.automationService.getProcessSetting(
			"EnrHeating",
			"ENR-25"
		);
		let enr25Cooling = await this.automationService.getProcessSetting(
			"EnrCooling",
			"ENR-25"
		);
		let enr25Coagulation = await this.automationService.getProcessSetting(
			"EnrCoagulation",
			"ENR-25"
		);
		let enr25Soaking = await this.automationService.getProcessSetting(
			"EnrSoaking",
			"ENR-25"
		);

		let enr50Mixing = await this.automationService.getProcessSetting(
			"EnrMixing",
			"ENR-50"
		);
		let enr50Heating = await this.automationService.getProcessSetting(
			"EnrHeating",
			"ENR-50"
		);
		let enr50Cooling = await this.automationService.getProcessSetting(
			"EnrCooling",
			"ENR-50"
		);
		let enr50Coagulation = await this.automationService.getProcessSetting(
			"EnrCoagulation",
			"ENR-50"
		);
		let enr50Soaking = await this.automationService.getProcessSetting(
			"EnrSoaking",
			"ENR-50"
		);

		let dpnrArray = dpnrMixing.data.data
			.concat(dpnrCoagulation.data.data)
			.concat(dpnrCreeping.data.data);

		let enr25Array = enr25Mixing.data.data
			.concat(enr25Heating.data.data)
			.concat(enr25Cooling.data.data)
			.concat(enr25Coagulation.data.data)
			.concat(enr25Soaking.data.data);

		let enr50Array = enr50Mixing.data.data
			.concat(enr50Heating.data.data)
			.concat(enr50Cooling.data.data)
			.concat(enr50Coagulation.data.data)
			.concat(enr50Soaking.data.data);

		this.dpnrProcesses = Object.keys(dpnrArray).map((key) => {
			let item = dpnrArray[key];
			item["isEditing"] = false;
			return item;
		});
		this.enr25Processes = Object.keys(enr25Array).map((key) => {
			let item = enr25Array[key];
			item["isEditing"] = false;
			return item;
		});
		this.enr50Processes = Object.keys(enr50Array).map((key) => {
			let item = enr50Array[key];
			item["isEditing"] = false;
			return item;
		});

		this.hideLoadingOverlay();
	},
	methods: {
		/**
		 * Show loading overlay.
		 */
		showLoadingOverlay() {
			this.$JsLoadingOverlay.show({ spinnerIcon: "ball-scale-multiple" });
		},

		/**
		 * Hide loading overlay.
		 */
		hideLoadingOverlay() {
			this.$JsLoadingOverlay.hide();
		},

		/**
		 * Switch tab between DPNR, ENR-25 and ENR-50.
		 *
		 * Available productID
		 * - DPNR
		 * - ENR-25
		 * - ENR-50
		 */
		switchTab(productId) {
			this.activeTab = productId;
			this.showLoadingOverlay();
			this.hideLoadingOverlay();
		},

		onEdit(item, index) {
			if (this.isEditing) {
				this.$swal("Error", "Only one edit per entry", "error");
				return;
			}
			this.isEditing = true;
			tempItem = JSON.parse(JSON.stringify(item));
			item.isEditing = true;
			switch (this.activeTab) {
				case "DPNR":
					this.$set(this.dpnrProcesses, index, item);
					break;
				case "ENR-25":
					this.$set(this.enr25Processes, index, item);
					break;
				case "ENR-50":
					this.$set(this.enr50Processes, index, item);
					break;
				default:
					break;
			}
		},

		onSave(item, index) {
			this.showLoadingOverlay();
			
			this.automationService
				.updateProcessSetting(
					item.productId,
					item.processId,
					item.parameterId,
					item.value
				)
				.then((response) => {
					console.log(response);
				})
				.finally(() => {
					this.isEditing = false;
					item.isEditing = false;
					switch (this.activeTab) {
						case "DPNR":
							this.$set(this.dpnrProcesses, index, item);
							break;
						case "ENR-25":
							this.$set(this.enr25Processes, index, item);
							break;
						case "ENR-50":
							this.$set(this.enr50Processes, index, item);
							break;
						default:
							break;
					}
					tempItem = null;

					this.hideLoadingOverlay();
				});
		},

		onCancel(index) {
			this.isEditing = false;
			switch (this.activeTab) {
				case "DPNR":
					this.$set(this.dpnrProcesses, index, tempItem);
					break;
				case "ENR-25":
					this.$set(this.enr25Processes, index, tempItem);
					break;
				case "ENR-50":
					this.$set(this.enr50Processes, index, tempItem);
					break;
				default:
					break;
			}
			tempItem = null;
		},

		saveRecipe() {
			// this.showLoadingOverlay();
			// var items = [];
			// this.recipes.forEach((item, index) => {
			// 	items.push({
			// 		material:
			// 			item.material.materialId === undefined
			// 				? item.material
			// 				: item.material.materialId,
			// 		sequence: index + 1,
			// 		weight: Number(item.weight),
			// 	});
			// });
			// const obj = {
			// 	items: items,
			// 	productId: this.activeTab,
			// };
			// // put recipe data.
			// this.recipeService.updateProductRecipe(obj).then((response) => {
			// 	if (response.status === 200) {
			// 		this.recipes = JSON.parse(JSON.stringify(items));
			// 		tempRecipes = null;
			// 		this.isEdit = false;
			// 	} else {
			// 		this.$swal({
			// 			title: "Error!",
			// 			text: "Error updating recipe, please try again later.",
			// 			icon: "error",
			// 			confirmButtonText: "OK",
			// 		});
			// 	}
			// 	this.hideLoadingOverlay();
			// });
		},
	},
};
</script>

<style lang="scss" scoped>
@import "../../assets/styles/pages/settings/recipe.scss";
@import "../../assets/styles/core/table.scss";
</style>